package immibis.infinitubes;

import immibis.core.api.porting.SidedProxy;
import immibis.core.microblock.BlockMicroblockContainer;

import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class InfiniTubeBlock extends BlockMicroblockContainer {
	public static Material material = new Material(MapColor.ironColor) {{
		setImmovableMobility();
	}};
	
	public InfiniTubeBlock(int id) {
		super(id, material);
		setTextureFile("/immibis/infinitubes/world.png");
		setCreativeTab(CreativeTabs.tabTransport);
		setHardness(0.25f);
	}
	
	private int renderType = SidedProxy.instance.getUniqueBlockModelID("immibis.infinitubes.InfiniTubeStaticRenderer", true);
			
	@Override
	public int wrappedGetRenderType() {
		return renderType;
	}

	public static boolean connects(IBlockAccess w, int x, int y, int z, int tubeSide) {
		Block block = Block.blocksList[w.getBlockId(x, y, z)];
		if(block == InfiniTubes.tube)
			return true;
		if(block == InfiniTubes.machines) {
			MachineTileBase mt = (MachineTileBase)w.getBlockTileEntity(x, y, z);
			return mt.connectsOnSide(tubeSide ^ 1);
		}
		return false;
	}
	
	@Override
	public TileEntity createNewTileEntity(World world, int metadata) {
		return new InfiniTubeTile();
	}
	
	@Override
	public void getSubBlocks(int par1, CreativeTabs par2CreativeTabs, List par3List) {
		par3List.add(new ItemStack(this, 1, 0));
	}
	
	@Override
	public void onBlockAdded(World world, int x, int y, int z) {
		super.onBlockAdded(world, x, y, z);
		WorldTubeMap.getForWorld(world).addTube(x, y, z);
	}
	
	@Override
	public void breakBlock(World world, int x, int y, int z, int blockID, int meta) {
		WorldTubeMap.getForWorld(world).removeTube(x, y, z);
		super.breakBlock(world, x, y, z, blockID, meta);
	}
}
