package immibis.infinitubes;

import immibis.core.microblock.EnumPosition;
import immibis.core.microblock.EnumPositionClass;
import immibis.core.microblock.PartType;
import immibis.core.microblock.TileCoverableBase;
import net.minecraft.util.AxisAlignedBB;

public class InfiniTubeTile extends TileCoverableBase {

	public InfiniTubeTile() {
		super(InfiniTubes.tube, 0.25);
	}

	@Override
	public boolean isPlacementBlockedByTile(PartType type, EnumPosition pos) {
		return pos.clazz == EnumPositionClass.Post || type.size > 0.25;
	}

	@Override
	public boolean isPositionOccupiedByTile(EnumPosition pos) {
		return pos == EnumPosition.Centre;
	}

	@Override
	public EnumPosition getPosition(int subHit) {
		return EnumPosition.Centre;
	}

	@Override
	public AxisAlignedBB getAABBFromPool(int subHit) {
		return AxisAlignedBB.getAABBPool().addOrModifyAABBInPool(0.25, 0.25, 0.25, 0.75, 0.75, 0.75);
	}

	@Override
	protected int getNumTileOwnedParts() {
		return 1;
	}
	
	

}
